--*******************************************************************************
--*                          Real-Time plasma                                   *
--*  Coded by: Cameron Buschardt                                                *
--*                                                                             *
--* Notes: this is my first attempt at plasma!  It probably needs lots o' work  *
--*        on the pal gen!                                                      *
--*******************************************************************************
without type_check
include get.e
include graphics.e
include machine.e
without warning
integer rt
sequence s
--  ***************************** set pixel widht + height
constant ps=2 --1 is too slow on my 133
--  ***************************** set zoom the bigger the clost
constant zm=100
constant vs=1800 --virtual size
--  ***************************** speed
constant your=4  --your value here
constant speed=floor(your/ps)
--  ***************************** screen size
constant xw=320
constant yw=200
--  ***************************** screen mode
constant md=19
--  ***************************** # of pal rotations per redraw
constant palp=5
--Start vals
constant es1=1
constant es2=2
constant es3=3
constant es4=4
--*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
sequence pal
integer e1,e2,e3,e4
integer col
object dmp
sequence cost,e
object p
e=repeat(4,4)
p=repeat(0,320)
--Cosine chart
cost=repeat(0,vs)
for x=0  to vs-1 by 1  do
    cost[x+1]=(floor((cos(x/zm))*255)) --try tan here !?!   
end for
rt=0
--Draw plasma
procedure plasm(integer e1,integer e2,integer e3,integer e4)
object tt
integer ee1,ee2
integer inn
for x=1  to yw by ps do
    for y=1  to xw by ps do
	inn=cost[e1+y]+cost[e2+y]+cost[e3+y]+cost[e4+y]+rt
	for xx=0  to ps-1  by 1 do
	   p[y+xx]=inn
	end for
    end for
for r=0  to ps-1 by 1 do
poke(#A0000 + (x+r)*320,p)  --*** faster, but works only in mode 19
end for
    e3=e3+1
    e4=e4+1
end for
end procedure
e1=es1
e2=es2
e3=es3
e4=es4
s=repeat(0,4)
s[1]=speed
s[2]=speed
s[3]=speed
s[4]=speed
pal={}
integer h,l
for x=0 to 128 do
    l=floor(x/256*63)
    pal=pal & {{43-l,0,l}}
end for
for x=129  to 1 by -1 do
    pal=pal & {pal[x]}
end for
use_vesa(1)
dmp=graphics_mode(md)
all_palette(pal)
while 1 do
if get_key()!=-1 then
    exit 
end if
rt=rt+palp
if rt>255 then
    rt=0
end if
for x=1  to 4  by 1 do
e[x]=e[x]+s[x]
end for
for x=1  to 4 by 1 do
    if e[x]>=vs-440 then
	e[x]=319   
	s[x]=-s[x]
    end if
    if e[x]<=0 then
	s[x]=-s[x]
	e[x]=0
    end if
end for
plasm(e[1],e[2],e[3],e[4])  
end while
dmp=wait_key()
dmp=graphics_mode(-1)


